c
      subroutine greenc(soft,L,gp3,diff)
      parameter(tpi=6.28318530717959,ipn=2)
c
      dimension gp3(L/2+1,L/2+1,L/2+1),diff(L/2+1,L/2+1,L/2+1)
c
      double precision Sprf
      shp2(x)=12.d0*(2.d0-2.d0*cos(dble(x))-dble(x)*sin(dble(x)))
     x     /dble(x)**4
c
      df=2.*tpi/float(L**3)
      gf=df
c
      tpiL=tpi/float(L)
      L2=L/2
      Lc=L/2+1
      Le=L/4+1
c
      af=2./15.
      do 400 igz=1,Lc
       rkz=tpiL*float(igz-1)
       s1z=sin(rkz)
       c1z=cos(rkz)
       s2z=sin(rkz/2.)
       s2z2=s2z**2
       psz=2.*s2z
       sz=sin(rkz/4.)**2
       cz=1.-sz
       do 400 igy=1,igz
        rky=tpiL*float(igy-1)
        s1y=sin(rky)
        c1y=cos(rky)
        s2y=sin(rky/2.)
        s2y2=s2y**2
        psy=2.*s2y
        sy=sin(rky/4.)**2
        cy=1.-sy
        do 400 igx=1,igy
         rkx=tpiL*float(igx-1)
         s1x=sin(rkx)
         c1x=cos(rkx)
         s2x=sin(rkx/2.)
         s2x2=s2x**2
         psx=2.*s2x
         sx=sin(rkx/4.)**2
         cx=1.-sx
         gp3t=0.
         difft=0.
c
         itest=mod(igx-1,L2)+mod(igy-1,L2)+mod(igz-1,L2)
c
         if(itest.ne.0)then
c
          rk2=rkx*rkx+rky*rky+rkz*rkz
c
          SUM=0.
          SRx=0.
          SRy=0.
          SRz=0.
          do 500 nz=-ipn,ipn
           rkzn=rkz-tpi*nz
           qz=1.
           if(rkzn.ne.0.)qz=psz/rkzn
           do 500 ny=-ipn,ipn
            rkyn=rky-tpi*ny
            qy=1.
            if(rkyn.ne.0.)qy=psy/rkyn
            do 500 nx=-ipn,ipn
             rkxn=rkx-tpi*nx
             qx=1.
             if(rkxn.ne.0.)qx=psx/rkxn
c
             qt=(qx*qy*qz)**3
c
             rk2n=rkxn*rkxn+rkyn*rkyn+rkzn*rkzn
c 
             Sprf=shp2(soft*sqrt(rk2n)/2.)
             SprfU=Sprf*qt
             st=SprfU*SprfU/rk2n
c
             SUM=SUM+st
             SRx=SRx+rkxn*st
             SRy=SRy+rkyn*st
             SRz=SRz+rkzn*st
500       continue
c
          SAa=(1.+s2x2*(af*s2x2-1.))
     x       *(1.+s2y2*(af*s2y2-1.))
     x       *(1.+s2z2*(af*s2z2-1.))
          Sd=SAa**2
c
          Dkx1=s1x*(1.+c1y+c1z)
          Dky1=s1y*(1.+c1z+c1x)
          Dkz1=s1z*(1.+c1x+c1y)
c
          Dkx=2.*Dkx1
          Dky=2.*Dky1
          Dkz=2.*Dkz1
c
          DWR=(SRx*Dkx+SRy*Dky+SRz*Dkz)/(Dkx*Dkx+Dky*Dky+Dkz*Dkz)
c
          gp3t=gf*DWR/Sd
c
          difft=df*SUM/Sd
c
          fr=1.
          if(igx.eq.1 .or. igx.eq.Lc)fr=fr*2.
          if(igy.eq.1 .or. igy.eq.Lc)fr=fr*2.
          if(igz.eq.1 .or. igz.eq.Lc)fr=fr*2.
          difft=difft/fr
c
         end if
         gp3(igx,igy,igz)=gp3t
         gp3(igx,igz,igy)=gp3t
         gp3(igy,igz,igx)=gp3t
         gp3(igy,igx,igz)=gp3t
         gp3(igz,igx,igy)=gp3t
         gp3(igz,igy,igx)=gp3t
c
         diff(igx,igy,igz)=difft
         diff(igx,igz,igy)=difft
         diff(igy,igz,igx)=difft
         diff(igy,igx,igz)=difft
         diff(igz,igx,igy)=difft
         diff(igz,igy,igx)=difft
400   continue
c
      do 300 iz=1,Lc
       do 300 iy=1,Lc
300   diff(Le,iy,iz)=0.5*diff(Le,iy,iz)
c
      return
      end
