c
      subroutine igreenc(sfts,sftl,L,gi3,difi,gl,Uslf)
      parameter(tpi=6.28318530717959)
c
      dimension gi3(L+1,L+1,L+1),difi(L+1,L+1,L+1)
      dimension gl(2*L+1,2*L+1,2*L+1)
c
      df=1./(float((2*L)**3)*8.)
c
      L2=2*L
      L4=4*L
      L2p2=2*L+2
      tpiL=tpi/float(L2)
c
      do 400 iz=1,2*L+1
       do 400 iy=1,iz
        do 400 ix=1,iy
         rad=0.5*sqrt(float((ix-1)**2+(iy-1)**2+(iz-1)**2))
         call S2(rad,sfts,grav,pot1)
         call S2(rad,sftl,grav,pot2)
         gtmp=pot1-pot2
         if(rad.eq.0.)Uslf=0.5*gtmp
         gtmp=df*gtmp
         gl(ix,iy,iz)=gtmp
         gl(ix,iz,iy)=gtmp
         gl(iy,iz,ix)=gtmp
         gl(iy,ix,iz)=gtmp
         gl(iz,ix,iy)=gtmp
         gl(iz,iy,ix)=gtmp
400   continue
c
      call realevenfft(gl,L4)
c
      af=2./15.
      do 500 ikz=1,L+1
       rkz=tpiL*(ikz-1)
       s1z=sin(rkz)
       c1z=cos(rkz)
       s2z=sin(rkz/2.)
       s2z2=s2z**2
       psz=2.*s2z
       sz=sin(rkz/4.)**2
       cz=1.-sz
       do 500 iky=1,ikz
        rky=tpiL*(iky-1)
        s1y=sin(rky)
        c1y=cos(rky)
        s2y=sin(rky/2.)
        s2y2=s2y**2
        psy=2.*s2y
        sy=sin(rky/4.)**2
        cy=1.-sy
        do 500 ikx=1,iky
         rkx=tpiL*(ikx-1)
         s1x=sin(rkx)
         c1x=cos(rkx)
         s2x=sin(rkx/2.)
         s2x2=s2x**2
         psx=2.*s2x
         sx=sin(rkx/4.)**2
         cx=1.-sx
c
         SRx=0.
         SRy=0.
         SRz=0.
         SUM=0.
         do 501 inz=0,1
          icz=ikz
          if(inz.eq.1)icz=L2p2-ikz
          rkzn=rkz-tpi*inz
          qz=1.
          if(rkzn.ne.0.)qz=psz/rkzn
          do 501 iny=0,1
           icy=iky
           if(iny.eq.1)icy=L2p2-iky
           rkyn=rky-tpi*iny
           qy=1.
           if(rkyn.ne.0.)qy=psy/rkyn
           do 501 inx=0,1
            icx=ikx
            if(inx.eq.1)icx=L2p2-ikx
            rkxn=rkx-tpi*inx
            qx=1.
            if(rkxn.ne.0.)qx=psx/rkxn
c
            st=gl(icx,icy,icz)*(qx*qy*qz)**6
            SUM=SUM+st
            SRx=SRx+rkxn*st
            SRy=SRy+rkyn*st
            SRz=SRz+rkzn*st
 501     continue
c
         SU2=(1.+s2x2*(af*s2x2-1.))
     x      *(1.+s2y2*(af*s2y2-1.))
     x      *(1.+s2z2*(af*s2z2-1.))
c
         Sd=SU2**2
c
         Dkx=s1x*(1.+c1y+c1z)
         Dky=s1y*(1.+c1z+c1x)
         Dkz=s1z*(1.+c1x+c1y)
c     
         D2=(Dkx*Dkx+Dky*Dky+Dkz*Dkz)
         gtmp=0.
         if(D2 .ne. 0.)gtmp=(SRx*Dkx+SRy*Dky+SRz*Dkz)/(D2*Sd)
         gtmp=0.5*gtmp
c
         dtmp=SUM/Sd
c
         fr=1.
         if(ikx.eq.1 .or. ikx.eq.L+1)fr=0.5*fr
         if(iky.eq.1 .or. iky.eq.L+1)fr=0.5*fr
         if(ikz.eq.1 .or. ikz.eq.L+1)fr=0.5*fr
         dtmp=fr*dtmp
c
         gi3(ikx,iky,ikz)=gtmp
         gi3(iky,ikz,ikx)=gtmp
         gi3(ikz,ikx,iky)=gtmp
         gi3(iky,ikx,ikz)=gtmp
         gi3(ikz,iky,ikx)=gtmp
         gi3(ikx,ikz,iky)=gtmp
c
         difi(ikx,iky,ikz)=dtmp
         difi(iky,ikz,ikx)=dtmp
         difi(ikz,ikx,iky)=dtmp
         difi(iky,ikx,ikz)=dtmp
         difi(ikz,iky,ikx)=dtmp
         difi(ikx,ikz,iky)=dtmp
500   continue
c
      Le=L/2+1
      do 600 iy=1,L+1
       do 600 ix=1,L+1
600    difi(ix,iy,Le)=0.5*difi(ix,iy,Le)
c
c      Uslf=0.5*Uslf
c
      return
      end
