c
c *********************************************************************
c prun depends upon the following routines:
c       step, infout, nget, input, output, updaterv, grav, force,
c       refine, rfinit, load, clist, uload, list, shforce, shgravll,
c       mesh, assign, gridf10, interp, imesh, irim, iassign, igridf10,
c       iinterp, green, greenc, igreen, igreenc, s2, cnvl, icnvlt,
c       realevenfft, errfit, cputime, lblnk, arraycheck, fourn, plref,
c       mxfnd, nmaxw, nlab, lmesh
c
c
      program prun
c      subroutine prun
      include 'psize.f'
      include 'pinfo.f'
c
      character startfile*60,greendir*60,datadir*60
c
      common /datadir/datadir
      common /greendir/greendir
c
      real r(3,Nmax),v(3,Nmax)
c
      call arraycheck
c
      open(55,file='prun.dat',status='old')
      read(55,'(a)')greendir
      read(55,'(a)')datadir
      read(55,'(a)') startfile
c
      nobj=Nget(startfile)
      if(nobj.gt.Nmax)stop 'N>Nmax'
      call input(nobj,r,v,startfile)
c
      read(55,*) irun
      read(55,*) ipstop,ipout,ipdump
      read(55,*) dpnp1,alphat
      read(55,*) sftinit,sftmin
      read(55,*) perr,nlmx
      close(55)
c
      if(ips.eq.0)then
         alpha=alphat
         p=3./2./alpha
      end if
c
      call infout(irun,'r')
c
      call step(nobj,r,v)
c
c      return
      stop
      end
