c
c ********************************************************************
c pstart depends upon the following routines:
c       zdisp, displ, assign, infout, output, initr, potin, gridf10,
c       interp, shgravll, shforce, list, s2, greenf, greenfc, green,
c       greenc, cnvl, cputime, lblnk, errfit, ran3, fourn, pow
c
c
      program pstart
c      subroutine pstart
      include 'psize.f'
      include 'pinfo.f'
c
      character greendir*60,datadir*60
c
      common /greendir/greendir
      common /datadir/datadir
c
      real r(3,Nmax),v(3,Nmax)
c
      open(55,file='pstart.dat',status='old')
      read(55,'(a)')greendir
      read(55,'(a)')datadir
c
      read(55,*)istart
      read(55,*)nobj,L
      read(55,*)soft,perr,alpha
      read(55,*)iru
      read(55,*)iseed1,iseed2
      read(55,*)rLbox
      read(55,*)delta
      close(55)
c
      if(nobj.gt.Nmax)stop 'N>Nmax'
c
      dpn=0.
      p=3./2./alpha
      aexp=1.
      ips=0
      irun=0
      sftinit=soft
c
      call infout(istart,'s')
c
      call initr(iru,n1d,spc,ial,iseed1,L,nobj,r)
      call zdisp(soft,perr,ial,spc,delta,iseed2,
     x rLbox,Usm,Uf,Us,nobj,r,v,L)
c
      T=0.
      do 3 i=1,nobj
 3    T=T+v(1,i)**2+v(2,i)**2+v(3,i)**2
      T=0.5*T
c
      Tst=T
      Tsum=0.
      Ust=Uf+Us
      Uh=Ust
      Usum=0.
      delI=0.
      delC=0.
      dfCU=0.
c
      call output(nobj,r,v,istart,1)
      call infout(istart,'s')
c
c      return
      stop
      end
