c
c
      subroutine cnvl(d3,L,g3,diff,U)
      dimension d3(L,L,L),g3(L/2+1,L/2+1,L/2+1),diff(L/2+1,L/2+1,L/2+1)
      double precision tpiN,sr,cr,snr,cnr,tmp
      integer nnh(3)
      tpiN=6.28318530717959d0/float(L)
      snr=sin(tpiN)
      cnr=-2.0d0*sin(0.5d0*tpiN)**2
      nnh(1)=L/2
      nnh(2)=L
      nnh(3)=L
      call fourn(d3,nnh,3,+1)
c
      U=0.
c
      sr=0.
      cr=1.
      do 100 ix=1,L/4+1
       icx=mod(L/2-ix+1,L/2)+1
       igx=L/2-ix+2
       inx=2*ix-1
       incx=2*icx-1
       S=sr
       C=cr
       do 101 iy=1,L/2+1
        icy=mod(L-iy+1,L)+1
        igy=iy
        do 101 iz=1,L/2+1
         icz=mod(L-iz+1,L)+1
         igz=iz
c
         dsum=diff(ix,igy,igz)+diff(igx,igy,igz)
         ddif=diff(ix,igy,igz)-diff(igx,igy,igz)
         da=dsum+S*ddif
         db=2.*C*ddif
         dc=dsum-S*ddif
         U=U+(d3(inx,iy ,iz )**2+d3(inx+1,iy ,iz )**2
     x      + d3(inx,iy ,icz)**2+d3(inx+1,iy ,icz)**2
     x      + d3(inx,icy,iz )**2+d3(inx+1,icy,iz )**2
     x      + d3(inx,icy,icz)**2+d3(inx+1,icy,icz)**2)*da
c
     x      +(d3(inx  ,iy ,iz )*d3(incx+1,icy,icz)+
     x        d3(inx+1,iy ,iz )*d3(incx  ,icy,icz)
     x      + d3(inx  ,iy ,icz)*d3(incx+1,icy,iz )+
     x        d3(inx+1,iy ,icz)*d3(incx  ,icy,iz )
     x      + d3(inx  ,icy,iz )*d3(incx+1,iy ,icz)+
     x        d3(inx+1,icy,iz )*d3(incx  ,iy ,icz)
     x      + d3(inx  ,icy,icz)*d3(incx+1,iy ,iz )+
     x        d3(inx+1,icy,icz)*d3(incx  ,iy ,iz ))*db
c
     x      +(d3(incx,iy ,iz )**2+d3(incx+1,iy ,iz )**2
     x      + d3(incx,iy ,icz)**2+d3(incx+1,iy ,icz)**2
     x      + d3(incx,icy,iz )**2+d3(incx+1,icy,iz )**2
     x      + d3(incx,icy,icz)**2+d3(incx+1,icy,icz)**2)*dc
c
         gsum=0.5*(g3(ix,igy,igz)+g3(igx,igy,igz))
         gdif=0.5*(g3(ix,igy,igz)-g3(igx,igy,igz))
         ga=gsum+S*gdif
         gb=C*gdif
         gc=gsum-S*gdif
         d000r=d3(inx,iy,iz)*ga+d3(incx+1,icy,icz)*gb
         d000i=d3(inx+1,iy,iz)*ga+d3(incx,icy,icz)*gb
         d100r=d3(incx,iy,iz)*gc+d3(inx+1,icy,icz)*gb
         d100i=d3(incx+1,iy,iz)*gc+d3(inx,icy,icz)*gb
         d010r=d3(inx,icy,iz)*ga+d3(incx+1,iy,icz)*gb
         d010i=d3(inx+1,icy,iz)*ga+d3(incx,iy,icz)*gb
         d110r=d3(incx,icy,iz)*gc+d3(inx+1,iy,icz)*gb
         d110i=d3(incx+1,icy,iz)*gc+d3(inx,iy,icz)*gb
         d001r=d3(inx,iy,icz)*ga+d3(incx+1,icy,iz)*gb
         d001i=d3(inx+1,iy,icz)*ga+d3(incx,icy,iz)*gb
         d101r=d3(incx,iy,icz)*gc+d3(inx+1,icy,iz)*gb
         d101i=d3(incx+1,iy,icz)*gc+d3(inx,icy,iz)*gb
         d011r=d3(inx,icy,icz)*ga+d3(incx+1,iy,iz)*gb
         d011i=d3(inx+1,icy,icz)*ga+d3(incx,iy,iz)*gb
         d111r=d3(incx,icy,icz)*gc+d3(inx+1,iy,iz)*gb
         d111i=d3(incx+1,icy,icz)*gc+d3(inx,iy,iz)*gb
         d3(inx,iy,iz)=d000r
         d3(inx+1,iy,iz)=d000i
         d3(incx,iy,iz)=d100r
         d3(incx+1,iy,iz)=d100i
         d3(inx,iy,icz)=d001r
         d3(inx+1,iy,icz)=d001i
         d3(incx,iy,icz)=d101r
         d3(incx+1,iy,icz)=d101i
         d3(inx,icy,iz)=d010r
         d3(inx+1,icy,iz)=d010i
         d3(incx,icy,iz)=d110r
         d3(incx+1,icy,iz)=d110i
         d3(inx,icy,icz)=d011r
         d3(inx+1,icy,icz)=d011i
         d3(incx,icy,icz)=d111r
         d3(incx+1,icy,icz)=d111i
101    continue
       tmp=sr
       sr=sr*cnr+cr*snr+sr
       cr=cr*cnr-tmp*snr+cr
100   continue
      call fourn(d3,nnh,3,-1)
c
      U=0.5*U
c
      return
      end
