c
      subroutine realevenfft(g,L)
      parameter(Lmax=1024)
      real g(L/2+1,L/2+1,L/2+1),work(Lmax)
      double precision tpiN,sr,cr,snr,cnr,tmp
c
      if(L.gt.Lmax)stop 'realevenfft error'
      tpiN=2.*3.14159625/float(L)
      tpiN=6.28318530717959d0/float(L)
      snr=sin(tpiN)
      cnr=-2.0d0*sin(0.5d0*tpiN)**2
c
      L2p1=L/2+1
      do 400 iz=1,L2p1
       do 400 iy=1,L2p1
c
        sr=0.
        cr=1.
        do 401 ix=1,L/2
         igx=L/2+2-ix
         work(2*ix-1)=g(ix,iy,iz)+g(igx,iy,iz)
         work(2*ix)=2.*(g(ix,iy,iz)-g(igx,iy,iz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 401    continue
        call fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 402 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(nr,iy,iz)=work(nr)
           g(ni,iy,iz)=work(ni)-Gt
           Gt=g(ni,iy,iz)
 402    continue
        g(L/2+1,iy,iz)=work(L/2+1)
 400  continue
c
      do 500 iz=1,L2p1
       do 500 ix=1,L2p1
c
        sr=0.
        cr=1.
        do 501 iy=1,L/2
         igy=L/2+2-iy
         work(2*iy-1)=g(ix,iy,iz)+g(ix,igy,iz)
         work(2*iy)=2.*(g(ix,iy,iz)-g(ix,igy,iz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 501    continue
        call fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 502 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(ix,nr,iz)=work(nr)
           g(ix,ni,iz)=work(ni)-Gt
           Gt=g(ix,ni,iz)
 502    continue
        g(ix,L/2+1,iz)=work(L/2+1)
 500  continue
c
      do 600 iy=1,L2p1
       do 600 ix=1,L2p1
c
        sr=0.
        cr=1.
        do 601 iz=1,L/2
         igz=L/2+2-iz
         work(2*iz-1)=g(ix,iy,iz)+g(ix,iy,igz)
         work(2*iz)=2.*(g(ix,iy,iz)-g(ix,iy,igz))*cr
         tmp=sr
         sr=sr*cnr+cr*snr+sr
         cr=cr*cnr-tmp*snr+cr
 601    continue
        call fourn(work,L/2,1,1)
        Gt=work(2)/2.
        do 602 i=1,L/4
           nr=2*i-1
           ni=nr+1
           g(ix,iy,nr)=work(nr)
           g(ix,iy,ni)=work(ni)-Gt
           Gt=g(ix,iy,ni)
 602    continue
        g(ix,iy,L/2+1)=work(L/2+1)
 600  continue
c
      return
      end
