c
      subroutine refine(N,Ls,ihc,nhc,ibc,err,nlmx)
      include 'psize.f'
c
c Lp - mesh points, pp - position, sp - size
c
      integer Lpt(mpmax),isp(mpmax),is(mpmax)
c
      common /rfprm/ NLins(4,0:mpmax),psf(5,0:mpmax),mp,ip
c
      integer ihc(Ls**3),nhc(Ls**3)
c
      Ls2=Ls*Ls
      Lsm1=Ls-1
c
      rL=float(NLins(2,0))
      rL1=10.*rL
c
      nlv=-1
      ipar=ip
 11   nlv=nlv+1
      ipar=NLins(3,ipar)
      if(ipar.ge.0)goto 11
      mpt=0
      if(nlv.lt.nlmx)call plref(Ls,nhc,mpt,Lpt,isp,is,N,ibc,err)
c
      N1=N+1
      if(ibc.eq.0)then
       Lsoff=1
      else if(ibc.eq.1)then
       Lsoff=0
      end if
c
      spfac=psf(4,ip)/float(Ls-2*Lsoff)
      spoffp1=spfac*(1.+Lsoff)+1.
      pxsm1=psf(1,ip)-spoffp1+rL1
      pysm1=psf(2,ip)-spoffp1+rL1
      pzsm1=psf(3,ip)-spoffp1+rL1
c
      mpo=mp
      mp=min(mpo+mpt,mpmax)
      write(77,'(''  New refinements = '',i5,
     x      '' (total ='',i5,'')'',/)')mpt,mp
      do 301 ipt=mpo+1,mp
       jpt=ipt-mpo
       ism1=is(jpt)-1
       ispt=isp(jpt)
       ixs=mod(ispt-1,Ls)+1
       iys=mod((ispt-1)/Ls,Ls)+1
       izs=(ispt-1)/Ls2+1
c
       NLins(1,ipt)=0
       NLins(2,ipt)=Lpt(jpt)
       NLins(3,ipt)=ip
       NLins(4,ipt)=0
       psf(1,ipt)=mod(pxsm1+spfac*ixs,rL)+1.
       psf(2,ipt)=mod(pysm1+spfac*iys,rL)+1.
       psf(3,ipt)=mod(pzsm1+spfac*izs,rL)+1.
       psf(4,ipt)=spfac*is(jpt)
c
       do 3003 iz=izs,izs+ism1
        icz=iz
        if(iz.lt.1 .or. iz.gt.Ls)then
         if(ibc.eq.0)goto 3003
         icz=mod(iz+Lsm1,Ls)+1
        end if
        do 3002 iy=iys,iys+ism1
         icy=iy
         if(iy.lt.1 .or. iy.gt.Ls)then
          if(ibc.eq.0)goto 3002
          icy=mod(iy+Lsm1,Ls)+1
         end if
         do 3001 ix=ixs,ixs+ism1
          icx=ix
          if(ix.lt.1 .or. ix.gt.Ls)then
           if(ibc.eq.0)goto 3001
           icx=mod(ix+Lsm1,Ls)+1
          end if
          ibox=icx+Ls*(icy-1)+Ls2*(icz-1)
          ihc(ibox)=ihc(ibox)+ipt*N1
          NLins(1,ipt)=NLins(1,ipt)+mod(abs(nhc(ibox)),N1)
 3001    continue
 3002   continue
 3003  continue
       if(NLins(1,ipt).gt.Npmax)stop 'Np>Npmax'
       write(77,'(i5,i7,i4,i5,4f8.3,i5,''  ('',i7,i4,'')'')')
     x         ipt,(NLins(jnd,ipt),jnd=1,3),
     x         (psf(jnd,ipt),jnd=1,4),jpt,ispt,ism1+1
 301  continue
c
      return
      end
