c
      subroutine shgravll(U,N,r,v,ll,L,Ls,ihc,re,ntp,G,D,dptl)
c
      real G(0:ntp),D(0:ntp)
c
      real r(3,N),v(3,N)
      integer ihc(Ls**3),ll(N)
c
      rL=float(L)
      re2=re**2
c
      delrad2=re2/float(ntp)
      delin=1./delrad2
c
      Us=0.
      Ubox=dptl*(float(N)/float(Ls**3))
      N1=N+1
c
      Ls1=Ls-1
      Ls2=Ls**2
c
      do 700 ibz=1,Ls
       do 700 iby=1,Ls
        do 700 ibx=1,Ls
c
         ibox=ibx+Ls*(iby-1)+Ls2*(ibz-1)
         ibrf=ihc(ibox)/N1
         is=ihc(ibox)-ibrf*N1
c
         Ustmp=0.
c
         nnb=0
         do 702 nbz=-1,0
           inbz=ibz+nbz
           rzadd=0.
           if(inbz.gt.Ls)then
              inbz=1
              rzadd=rL
           else if(inbz.lt.1)then
              inbz=Ls
              rzadd=-rL
           end if
           do 702 nby=-1,1
             inby=iby+nby
             ryadd=0.
             if(inby.gt.Ls)then
                inby=1
                ryadd=rL
             else if(inby.lt.1)then
                inby=Ls
                ryadd=-rL
             end if
             do 702 nbx=-1,1
               inbx=ibx+nbx
               rxadd=0.
               if(inbx.gt.Ls)then
                  inbx=1
                  rxadd=rL
               else if(inbx.lt.1)then
                  inbx=Ls
                  rxadd=-rL
               end if
               nnb=nnb+1
               if(nnb.eq.15)goto 712
c
                 nbox=inbx+Ls*(inby-1)+Ls2*(inbz-1)
                 nbrf=ihc(nbox)/N1
c Break to next box if in same refinement
                 if(ibrf.eq.nbrf .and. ibrf.ne.0)goto 711
c
c Loop over pairs in ibox and nbox -------------------------
                 i=is
 701             if(i.gt.0)then
                    r3i=r(3,i)-rzadd
                    r2i=r(2,i)-ryadd
                    r1i=r(1,i)-rxadd
c
                    j=ihc(nbox)-nbrf*N1
 703                if(j.eq.0 .or. j.eq.i)goto 710
c
c ************ Pair operation ************
c
                      rz=r3i-r(3,j)
                      if(rz.gt.re)goto 710
                      ry=r2i-r(2,j)
                      rx=r1i-r(1,j)
                      rad2=rx**2+ry**2+rz**2
c
                      grc=rad2*delin
                      igrc=int(grc)
                      if(igrc .ge. ntp)goto 666
                      gfrac=grc-igrc
                      Gr=G(igrc)+(G(igrc+1)-G(igrc))*gfrac
                      Ustmp=Ustmp+D(igrc)+(D(igrc+1)-D(igrc))*gfrac
c
                      v(1,i)=v(1,i)-rx*Gr
                      v(2,i)=v(2,i)-ry*Gr
                      v(3,i)=v(3,i)-rz*Gr
                      v(1,j)=v(1,j)+rx*Gr
                      v(2,j)=v(2,j)+ry*Gr
                      v(3,j)=v(3,j)+rz*Gr
c
 666                  continue
c ************************
c
                    j=ll(j)
                    goto 703
 710                continue
c
                    i=ll(i)
                    goto 701
                 end if
 711             continue 
c
 702     continue
c no more particles in ibox -------------------------------------
c 
 712     Us=Us+(Ustmp-Ubox)
c
 700  continue
c *************
c
      Us=1.*Us
      U=U+Us
c
      return
      end
