c
c *********************************************************************
c
      subroutine updaterv(N,r,v,dpnext)
      include 'pinfo.f'
      real r(3,N),v(3,N)
c
      rL=float(L)
      rL1=10.*rL-1.
      dmp=0.5*(dpn+dpnext)
      do 1 i=1,N
       r(1,i)=amod(r(1,i)+dmp*v(1,i)+rL1,rL)+1.
       r(2,i)=amod(r(2,i)+dmp*v(2,i)+rL1,rL)+1.
       r(3,i)=amod(r(3,i)+dmp*v(3,i)+rL1,rL)+1.
 1    continue
c
      if(dpnext.gt.0.)then
       p=p+0.5*dpnext
       dpD=(0.5+alpha)*dpnext/2./alpha/p
       dpv=(1.-dpD)/(1.+dpD)
       dpf=abs(9.*dpnext/(2.*alpha*p)**2/(1.+dpD))
c
       do 2 i=1,N
        v(1,i)=dpv*v(1,i)
        v(2,i)=dpv*v(2,i)
        v(3,i)=dpv*v(3,i)
 2     continue
c
       To=T
c
       write(77,'(1x//''Step '',i6,'' '',62(''=''))')ips+1
c
       ah=(2.*alpha*p/3.)**(1./alpha)
c
       soft=max(sftmin,sftinit/ah)
       call grav(dpf,soft,Uh,perr,nlmx,N,r,v,L)
       Uh=Uh-Usm
c
       close(77)
c
       T=0.
       do 3 i=1,N
 3     T=T+v(1,i)**2+v(2,i)**2+v(3,i)**2
       T=0.5*T
c
       p=p+0.5*dpnext
       aexpo=aexp
       aexp=(2.*alpha*p/3.)**(1./alpha)
       T=T*aexp**(2.*alpha-1.)
c
       daexp=aexp-aexpo
       Tsum=Tsum+0.5*(T+To)*daexp
       Usum=Usum+Uh*daexp
c
       delI=aexp*Tsum-Usum
       delC=delI-(aexp-1.)*(Tst-Ust)
       dfCU=0.
       if(Usum.ne.0.)dfCU=delC/Usum
c
      end if
c
      return
      end
